// C Header File
// Created 8/24/2002; 12:46:31 PM

#define NAME_VERSION_STRING "Pacman 3D v0.30"
#define AUTHOR_STRING "By Malcolm Smith"

#define MOVE_SPEED 3   //For movement speed (FAT normally is 1)

//Note that TURN_STEP/TURN_SPEED _must_ be an integer for 90-degree turns.
#define TURN_SPEED 3   //For turning speed  (FAT normally is 1)
#define TURN_STEP 12

#define GAME_START_LEVEL 1
#define GAME_START_LIVES 5

#define WON_QUIT_LEVEL 2

#define GHOST_LIMIT 5

#define WALL_TILE 1

#define BG_name CLOUDY_SKY__DARKGRAY_GROUND__BG
#define GRAPHICS_FILE_NAME "pac_gfx"

#define MAX_ONSCREEN_DOTS 3

#define LEVELCOUNT 6

#define THE_DOT_MODE SPRITEMODE_LOWER32
#define THE_GHOST_MODE SPRITEMODE_SIZE64

//My mini-absolute value macro
#define PACABS(a) ((a>0)?a:-a)

#ifndef FileConstants
#define FileConstants
enum FileConstants { HOWMANY = 50, MAXLEN = 9 };
#endif

short display_offsetx = 0; // will be set depending on calctype (TI89 or TI92p)
short display_offsety = 0; // will be set depending on calctype (TI89 or TI92p)


FATSPRITE      *allspr = NULL;           // the sprite structure POINTER itself

FATSPRITE      *dotspr;
FATSPRITE 		 *ghostspr;

char *ext_level_data = NULL;

TEXCONFIG      sprite_tex[4];            // textures for sprites

unsigned short *pac_img_data;

typedef struct
{
	short gamemode;
	short fatlogo;
	short paclogo;
	short ghost_count;
} ConfigStruct;

typedef struct
{
	short count;
	short left;
} DotStruct;

typedef struct
{
	short spawnx;
	short spawny;
	short move;
	short hiding;
	short count;
} GhostStructOne;

typedef struct
{
	short oldx;
	short oldy;
	short adjust;
} GhostStructMulti;

typedef struct
{
	short quitting;

	short lives;
	short level;
	
	short xsize;
	short ysize;
	
	short xcamcur;
	short ycamcur;
	
	short turn_delay;
	short turn_direction;
	short turn_flag;
	
	GhostStructOne ghosts;
	GhostStructMulti ghost[GHOST_LIMIT];
	
	DotStruct dot;
	
	ConfigStruct cfg;
	
} game_struct;

game_struct gamedata;

unsigned long count5_start;

typedef struct
{
	short dx;
	short dy;	
	short open;
	short orientation;
} GhostCheckStruct;
