// C Header File
// Created 8/24/2002; 9:34:17 PM

short DotGenerateFromMap(FATCONFIG *fc);
short InitGhosts(FATCONFIG *fc);

void InitGameStruct(void)
{
short a;
	gamedata.quitting = 0;

	gamedata.lives=GAME_START_LIVES;
	gamedata.level=GAME_START_LEVEL;
	
	gamedata.xsize = 20;
	gamedata.ysize = 22;
	
	gamedata.xcamcur = 96;
	gamedata.ycamcur = 96;
	
	gamedata.turn_delay = 0;
	gamedata.turn_direction = 0;
	gamedata.turn_flag = 0;
	
	gamedata.dot.count = 0;
	gamedata.dot.left = 0;
	gamedata.ghosts.count = 0;

	gamedata.ghosts.spawnx = 0;
	gamedata.ghosts.spawny = 0;
	gamedata.ghosts.move = 0;
	gamedata.ghosts.hiding = 0;
	for(a=0;a<gamedata.cfg.ghost_count;a++)
	{
		gamedata.ghost[a].adjust=0;	
		gamedata.ghost[a].oldx=0;
		gamedata.ghost[a].oldy=0;	
	}
	
	
	gamedata.cfg.gamemode = 0;
	gamedata.cfg.fatlogo = 1;
	gamedata.cfg.paclogo = 1;
	
	gamedata.cfg.ghost_count = 1;
}



void SetGameVariables(FATCONFIG *fc)
{
		fc->map_width = gamedata.xsize;
		fc->map_height = gamedata.ysize;

    gamedata.dot.count = DotGenerateFromMap(fc);        // generate dots for all map areas of type '0'
    gamedata.dot.left = gamedata.dot.count;
    gamedata.ghosts.count = InitGhosts(fc);
    fc->nr_sprites = 0;
    
    gamedata.xcamcur = fc->cam_xpos>>6;
    gamedata.ycamcur = fc->cam_ypos>>6;
    
	gamedata.ghosts.move = 0;
	gamedata.ghosts.hiding = 0;    
}

// Loads the config file
void LoadConfig(void)
{
	short n;
//This structure holds the data to be loaded.
ConfigStruct load_data;
	FILE *f;
	f = fopen("pac3dcfg", "rb");
// we must check to see if we opened the file successfully
	if (f != NULL) {
//Reads stuff
		n = fread(&load_data, sizeof(ConfigStruct), 1, f);
		fclose(f);
		gamedata.cfg.gamemode = load_data.gamemode;
		gamedata.cfg.fatlogo = load_data.fatlogo;
		gamedata.cfg.paclogo = load_data.paclogo;
		gamedata.cfg.ghost_count = load_data.ghost_count;
	} else {
//Error, oh well
	}
}



void SaveConfig(void)
{
	short n;
//Holds the data to save
ConfigStruct save_data;
	FILE *f;

	save_data.gamemode = gamedata.cfg.gamemode;
	save_data.fatlogo = gamedata.cfg.fatlogo;
	save_data.paclogo = gamedata.cfg.paclogo;
	save_data.ghost_count = gamedata.cfg.ghost_count;
	
	if ((SymFindPtr(SYMSTR("pac3dcfg"), 0)->flags.bits.archived) == 1)
		return;

	f = fopen("pac3dcfg", "wb");
// we must check to see if we opened the file successfully
	if (f != NULL) {
//Writes stuff
		n = fwrite(&save_data, sizeof(ConfigStruct), 1, f);
		fputc(0, f);
		fputs("pcfg", f);
		fputc(0, f);
		fputc(OTH_TAG, f);
		fclose(f);

	} else {
//Error, oh well
	}
}
